%INPUT: cell of simple unweighted graphs
%OUTPUT: cell of non-isomorphic graphs constructed by H2-step up  with n+1
%vertices, deletion and connections used to construct the new graph


function[H2,Step]=H2_3D(G)
H={};
H2={};
k=size(G,2);
Step=[];
S=1;



for h=1:k

A=G{h}; 
V=numnodes(A);
E=numedges(A);
[s,t]=findedge(A);

for i=1:E
   B= rmedge(A,s(i),t(i)); 
   B=addedge(B,[s(i) t(i)],[V+1 V+1]);
   L=1:V;
   L=L(L~=s(i));
   L=L(L~=t(i));
   
   for j1=1:V-3
       for j2=j1+1:V-2
            
            C=addedge(B,[L(j1) L(j2)],[V+1 V+1]);
           
           n1=size(H,2);
           flag=0;
           m=1;
           
           while m<n1+0.1 && flag==0
               
               if isisomorphic(C,H{m})
                flag=1;
               end
               m=m+1; 
           end
             
           
           if flag==0
           
             H2=cell(1,n1+1);
             H2(1:n1)=H;
             
             
             H2{n1+1}=C;
             H=H2;
             
             Step(S).remove=[s(i) t(i)];
             Step(S).add=[L(j1) L(j2)];
             
             S=S+1;
             
           end     
           
           
       end 
   end
   
   
   
   
end

end

end